#include <QApplication>
#include <QtCore>
#include <QtDBus>
#include <QClipboard>

class QCBAdapter: public QDBusAbstractAdaptor
 {
     Q_OBJECT
     Q_CLASSINFO("D-Bus Interface", "DBus.Manager.QClipboard")
     Q_PROPERTY(QString cbContent READ content WRITE setContent)

 private:
     QApplication *app;

 public:
     QCBAdapter(QApplication *application)
         : QDBusAbstractAdaptor(application)
     {
        cb =  QApplication::clipboard(); 
     }
     Q_INVOKABLE QString content()
     {
	printf("Запрос содержимого буфера обмена\n");
	return cb->text();
     }

     Q_INVOKABLE void setContent(const QString &newContent)
     {
	printf("Содержимое буфера обмена изменено\n");
         cb->setText(newContent);
     }

 public slots:
     Q_NOREPLY void emptyClipboard()
     { 
	cb->clear(); 
     }

private:
	QClipboard * cb;
 };
